""" sql_basic.py : demonstrator of some sql functionalities"""

print('\n' + ' //// Start my local Spark session //// ' + '\n')

from pyspark import SparkContext
from pyspark.sql import SQLContext
from pyspark.sql import SparkSession
from pyspark.sql.types import *


sc = SparkContext("local", "rdd application 2")
sc.setLogLevel("WARN")


sqlContext = SQLContext(sc)

dataFile = "./yellow_tripdata_2016-01_10k.csv"

taxiFile = sc.textFile(dataFile)
print("number of entries {}").format(taxiFile.count())
print("take first entry")
print(taxiFile.take(1))

# get first
header = taxiFile.first()
print('\n' + 'header is: \n {}').format(header)


from datetime import *
from dateutil.parser import parse
print(parse("2013-02-09 18:16:10"))  # test it:

taxiHeader = taxiFile.filter(lambda x: "VendorID" in x)
print('taxi header 2 ' + '\n')
print(taxiHeader.collect())


taxiNoHeader = taxiFile.subtract(taxiHeader)
print(taxiNoHeader.count())
print(' no header first element')
print(taxiNoHeader.first())


from pyspark.sql import Row

# 0 VendorID,
# 1 tpep_pickup_datetime,
# 2 tpep_dropoff_datetime,
# 3 passenger_count,
# 4 trip_distance,
# 5 pickup_longitude,
# 6 pickup_latitude,
# 7 RatecodeID,
# 8 store_and_fwd_flag,
# 9 dropoff_longitude,
# 10 dropoff_latitude,
# 11 payment_type,
# 12 fare_amount,
# 13 extra,
# 14 mta_tax,
# 15 tip_amount,
# 16 tolls_amount,
# 17 improvement_surcharge,
# 18 total_amount

#create the rdd
temp_taxiRDD = taxiNoHeader.map(lambda k: k.split(",")).map(lambda p: Row(ID=p[0], dateA=p[1], dateB=parse(p[2]), passenger=int(p[3]), dist=float(p[4]), fare=p[12], tip=p[15] ))


print('after mapping transformation number of elements>')
print(temp_taxiRDD.first())

print(' via SparkSession ' )
#spark = SparkSession(sc)
spark = SparkSession.builder.master("local").getOrCreate()

taxiDF=spark.createDataFrame(temp_taxiRDD)
print(taxiDF.count())
print(taxiDF.show())


